#include <avr/io.h>
#include <avr/interrupt.h>

#include "uart.h"
#include "i2c.h"

#define F_CPU           4000000      /* 4Mhz */
#define UART_BAUD_RATE  19200      /* 19200 baud */
#define BAUD			(F_CPU/(UART_BAUD_RATE*16l)-1)
#define WRITE			0
#define READ			1
#define ADDRESS			0xA0

void delay_5ms(void)
{
	/*
	 * Author:       Jochen Rurlnder
     * Version:      1.0
     * Datum  :      18.10.2003
     * Beschreibung:
     * Hier wird ein Delay von 15 Millisekunden erzeugt.
     * es werden 2 Taktzyklen mehr bentigt daher ist die Funktion um 0,5us ungenau
     */
     asm ("		ldi  r24, 0xa0    \n"
          "		ldi  r25, 0x0f    \n"
          "loop:				  \n"
          "		nop				  \n"
          "		sbiw r24,0x01     \n"
          "		brne loop         \n"
         ::);
}



void EE2_write(unsigned char wo, unsigned char was)
{
	unsigned int ret;
	ret = start_i2c(ADDRESS+WRITE);
    if ( !ret )
    {
    	write_i2c(wo);
    	write_i2c(was);    	
    }
    else
    {
    	USART_Transmit_string("WRITE nok");
    }
    /*
     * hier mal 15ms warten da ich aus dem Datenblatt entnommen habe das der so seine Zeit braucht bis er die Daten geschrieben hat.
     * Da steht auch was von Acknowlede Polling allerdings blick ich net wie das gehen soll ???
     */
    stop_i2c();
    delay_5ms();
    delay_5ms();
    delay_5ms();
}


int main(void)
{
	unsigned int i, ret;
	unsigned char byte[3];
	USART_INIT(BAUD);
	init_i2c();
	USART_Clear_Screen();
	USART_Transmit_string("Da kommt was an!");
	
    
	EE2_write(0x01,'J');
	EE2_write(0x02,'o');
	EE2_write(0x03,'c');
	EE2_write(0x04,'h');
	EE2_write(0x05,'e');
	EE2_write(0x06,'n');
	
    
	for(i=0; i<8; i++)
	{    			
		ret = start_i2c(ADDRESS+WRITE);
    	if ( !ret )
    	{
    		write_i2c(i);
    		ret = rep_start_i2c(ADDRESS+READ);
    		if ( !ret )
    		{
    			itoa(read_i2c_ack(), byte, 10);
    			USART_Transmit_string(byte);
    		}
    		else
    	    {
    		    USART_Transmit_string("Fehler 1;");
    		}
    	}
    	else
    	{
    		USART_Transmit_string("Fehler 2;");
    	}    	
    	stop_i2c();
    	
	}	
}
